﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TravellingSalesman.Models;
using TravellingSalesman.WorkWithFile;
using TravellingSalesman.WorkWithTable;

namespace TravellingSalesman.WorkWithUser
{
    internal class MethodsForUser
    {
        /// <summary>
        /// Input data in table graf
        /// </summary>
        public static void InputTable()
        {
            Console.WriteLine("Введите количество графов");
            int countGrafs = Convert.ToInt32(Console.ReadLine());
            int[,] arrayAll = new int[countGrafs + 1, countGrafs + 1];
            for (int i = 1; i < arrayAll.GetLength(0); i++)
            {
                Console.WriteLine($"Введите значения строки {i} через пробел");
                string rowValue = Console.ReadLine();
                string[] elementRow = rowValue.Split(" ");
                for (int j = 1; j < arrayAll.GetLength(1); j++)
                {
                    if (elementRow[j - 1] == "М" || elementRow[j - 1] == "M") arrayAll[i, j] = -1;
                    else arrayAll[i, j] = Convert.ToInt32(elementRow[j - 1]);
                }
            }
            for (int i = 0; i < arrayAll.GetLength(0); i++)
            {
                arrayAll[0, i] = i;
                arrayAll[i, 0] = i;
            }
            TableGraf.ArrayTableGraf = arrayAll;
        }
        public static void MainCicleWork()
        {
            int sumRowReductions = Reductions.StringReduction();
            int sumColumnReductions = Reductions.ColumnReduction();
            int startRoot = sumColumnReductions + sumRowReductions;
            OutputGraf.PrintGraf(startRoot);
            int[] arrayMaxZeroCellAndIndexs = CalculationOfGraphValues.CountMaximumZeroRating();
            int newWithoutRoot = 0;
            while (Checks.ChecksLenghtTable())
            {
                if (arrayMaxZeroCellAndIndexs[0] == TableGraf.M) newWithoutRoot = TableGraf.M;
                else newWithoutRoot = startRoot + arrayMaxZeroCellAndIndexs[0];
                List<List<int>> allRows = new List<List<int>>();
                for (int i = 0; i < TableGraf.ArrayTableGraf.GetLength(0); i++)
                {
                    if (i == arrayMaxZeroCellAndIndexs[1])
                    {
                        continue;
                    }
                    List<int> row = new List<int>();
                    for (int j = 0; j < TableGraf.ArrayTableGraf.GetLength(1); j++)
                    {
                        if (j == arrayMaxZeroCellAndIndexs[2])
                        {
                            continue;
                        }
                        row.Add(TableGraf.ArrayTableGraf[i, j]);
                    }
                    allRows.Add(row);
                }

                TableGraf.TempArrayTableGraf = new int[TableGraf.ArrayTableGraf.GetLength(0) - 1, TableGraf.ArrayTableGraf.GetLength(1) - 1];
                for (int i = 0; i < TableGraf.TempArrayTableGraf.GetLength(0); i++)
                {
                    for (int j = 0; j < TableGraf.TempArrayTableGraf.GetLength(1); j++)
                    {
                        TableGraf.TempArrayTableGraf[i, j] = allRows[i][j];
                    }
                }
                int indexSkip = TableGraf.ArrayTableGraf[0, arrayMaxZeroCellAndIndexs[2]];
                int indexSkipC = TableGraf.ArrayTableGraf[arrayMaxZeroCellAndIndexs[1], 0];
                int resI = 0;
                int resJ = 0;
                for (int i = 0; i < TableGraf.TempArrayTableGraf.GetLength(0); i++)
                {
                    if (TableGraf.TempArrayTableGraf[i, 0] == indexSkip) resI = i;
                    if (TableGraf.TempArrayTableGraf[0, i] == indexSkipC) resJ = i;

                }
                TableGraf.TempArrayTableGraf[resI, resJ] = TableGraf.M;
                sumRowReductions = Reductions.StringReduction(true);
                sumColumnReductions = Reductions.ColumnReduction(true);
                int newRoot = startRoot + sumRowReductions + sumColumnReductions;
                if (newRoot < newWithoutRoot)
                {
                    startRoot = newRoot;
                    Console.WriteLine($"С из {TableGraf.ArrayTableGraf[arrayMaxZeroCellAndIndexs[1], 0]} -> {TableGraf.ArrayTableGraf[0, arrayMaxZeroCellAndIndexs[2]]} стомость {startRoot}") ;
                    TableGraf.ArrayTableGraf = TableGraf.TempArrayTableGraf;
                    arrayMaxZeroCellAndIndexs = CalculationOfGraphValues.CountMaximumZeroRating();
                }
                else if (newRoot > newWithoutRoot)
                {
                    startRoot = newWithoutRoot;
                    Console.WriteLine($"Без из {TableGraf.ArrayTableGraf[arrayMaxZeroCellAndIndexs[1], 0]} -> {TableGraf.ArrayTableGraf[0, arrayMaxZeroCellAndIndexs[2]]} стомость {startRoot}");

                    TableGraf.ArrayTableGraf[arrayMaxZeroCellAndIndexs[1], arrayMaxZeroCellAndIndexs[2]] = TableGraf.M;
                    Reductions.StringReduction();
                    Reductions.ColumnReduction();
                    arrayMaxZeroCellAndIndexs = CalculationOfGraphValues.CountMaximumZeroRating();
                }
                else if (newRoot == newWithoutRoot)
                {
                    Console.WriteLine($"С из {TableGraf.ArrayTableGraf[arrayMaxZeroCellAndIndexs[1], 0]} -> {TableGraf.ArrayTableGraf[0, arrayMaxZeroCellAndIndexs[2]]} стомость {startRoot}");
                    TableGraf.ArrayTableGraf = TableGraf.TempArrayTableGraf;
                }
            }



          
        }
    }
}
